<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="tLang('product', '产品编码')" prop="code">
        <el-input v-model="queryParams.code" :placeholder="tLang('common', '请输入') + tLang('product', '产品编码')" clearable
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item :label="tLang('product', '步骤')" prop="step">
        <el-input v-model="queryParams.step" :placeholder="tLang('common', '请输入') + tLang('product', '步骤')" clearable
          @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="search" size="mini" @click="handleQuery">{{ tLang('common', '搜索') }}</el-button>
        <el-button icon="refresh" size="mini" @click="resetQuery">{{ tLang('common', '重置') }}</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="plus" size="mini" @click="handleAdd"
          v-hasPermi="['product:working:add']">{{ tLang('common', '新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['product:working:edit']">{{ tLang('common', '修改') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['product:working:remove']">{{ tLang('common', '删除') }}</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
    </el-row>
    <el-table v-loading="loading" :data="procedureList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" :label="tLang('common', '序号')" width="60" align="center" />
      <el-table-column :label="tLang('product', '产品编码')" align="center" v-if="columns[0].visible" prop="code" />
      <el-table-column :label="tLang('product', '第几次')" align="center" v-if="columns[1].visible" prop="num" />
      <el-table-column :label="tLang('product', '步骤')" align="center" v-if="columns[2].visible" prop="step" />
      <el-table-column :label="tLang('product', '最小针数')" align="center" v-if="columns[3].visible" prop="min" />
      <el-table-column :label="tLang('product', '最大针数')" align="center" v-if="columns[4].visible" prop="max" />
      <el-table-column :label="tLang('product', '排序')" align="center" v-if="columns[5].visible" prop="sort" />
      <el-table-column :label="tLang('product', '备注')" align="center" v-if="columns[6].visible" prop="remark" />
      <el-table-column :label="tLang('common', '操作')" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-tooltip content="修改" placement="top" v-if="scope.row.userId !== 1">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
              v-hasPermi="['product:working:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top" v-if="scope.row.userId !== 1">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
              v-hasPermi="['product:working:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <div class="pagination">
      <el-pagination :hide-on-single-page="true" v-model:current-page="queryParams.pageNum"
        v-model:page-size="queryParams.pageSize" :page-sizes="[25, 50, 100, 150]"
        layout="total, sizes, prev, pager, next, jumper" :total="total" @size-change="getList"
        @current-change="getList" />
    </div>
    <AddEdit :title="title" v-model="open" :form="form" @submitForm="submitForm"></AddEdit>
  </div>
</template>

<script setup>
import { ref, reactive, watch, onMounted } from 'vue'
import { listProcedure, getProcedure, delProcedure, addProcedure, updateProcedure } from "@/api/casm/product";
import AddEdit from './add_edit.vue';
const { proxy } = getCurrentInstance();

// 遮罩层
let loading = ref(true)
// 选中数组
let ids = ref([])
// 非单个禁用
let single = ref(true)
// 非多个禁用
let multiple = ref(true)
// 显示搜索条件
let showSearch = ref(false)
// 表单参数
let form = ref({})
// 是否显示弹出层
let open = ref(false)
// 弹出层标题
let title = ref("")
// 查询参数
let queryParams = reactive({
  pageNum: 1,
  pageSize: 10,
  code: null,
  num: null,
  step: null,
  min: null,
  max: null,
})

let total = ref(0)
// 设备信息表格数据
let procedureList = ref([])
// 列显隐信息
const columns = ref([
  { key: 0, label: proxy.tLang('product', '产品编码'), visible: true },
  { key: 1, label: proxy.tLang('product', '第几次'), visible: true },
  { key: 2, label: proxy.tLang('product', '步骤'), visible: true },
  { key: 3, label: proxy.tLang('product', '最小值'), visible: true },
  { key: 4, label: proxy.tLang('product', '最大值'), visible: true },
  { key: 5, label: proxy.tLang('product', '排序'), visible: true },
  { key: 6, label: proxy.tLang('product', '备注'), visible: true },
]);

let infoDialog = ref(false)
let productinfo = ref({})
/** 查询设备信息列表 */
function getList() {
  loading.value = true;
  listProcedure(queryParams).then(response => {
    procedureList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}
// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length !== 1
  multiple.value = !selection.length
}

//** 搜索按钮操作 */
function handleQuery() {
  queryParams.pageNum = 1;
  getList();
}
/** 重置按钮操作 */
function resetQuery() {
  queryParams.pageNum = 1
  queryParams.pageSize = 10
  queryParams.name = null
  queryParams.code = null

  handleQuery();
}
/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = proxy.tLang('common', '添加') + ' ' + proxy.tLang('product', '缝纫次数');
}




/** 提交按钮 */
function submitForm(propform) {
  if (propform.id != null) {
    updateProcedure(propform).then(response => {
      proxy.$modal.msgSuccess(proxy.tLang('common', '修改成功'));
      open.value = false;
      getList();
    });
  } else {
    addProcedure(propform).then(response => {
      proxy.$modal.msgSuccess(proxy.tLang('common', '新增成功'));
      open.value = false;
      getList();
    });
  }
}


// 取消按钮
function cancel() {
  open.value = false;
  reset();
}
// 表单重置
function reset() {
  form.value = {
    id: null,
    code: '',
    num: 1,
    step: '',
    min: 1,
    max: 1,
    sort: "",
    remark: "",
  };
  //resetForm("form");
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const id = row.id || ids.value
  getProcedure(id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = proxy.tLang('common', '修改') + ' ' + proxy.tLang('product', '缝纫次数');
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const id = row.id || ids.value;
  proxy.$modal.confirm(proxy.tLang('tip', '确定删除选中记录？') + ` [${id}]`).then(function () {
    return delProcedure(id);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess(proxy.tLang('common', '删除成功'));
  }).catch(() => { });
}
onMounted(() => {
  getList();
})
</script>

<style lang="scss" scoped>
.pagination {
  width: 100%;
  margin: 10px;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
